from neuron import h
import numpy as np
from glob import glob as listdir
import os
from shutil import copyfile
import h5py as h5
from GUI import Panels
from branch_setup import *
from protocol import *

global panel,v_vec_spine1_matrix

v_vec_spine1_matrix=[]
v_vec_spine2_matrix=[]
cai_vec_spine1_matrix=[]
cai_vec_spine2_matrix=[]
CVOde = h.cvode
CVOde.active(0)

p = {}
exec(compile(open('parameters.py').read(), 'parameters.py', 'exec'),p)

# Change initialization time
p['time_on_initialization'] = 100 #100
p['time_to_begin_induction'] = 20 # ms #20


branch = Spiny_branch(p) #problema restart kernel


protocol = stim_protocol(branch,p)

#h.tstop = 2e4


colors = list(range(1,9))
restricted_colors = list(range(2,9))
# Brushes
brush = list(range(1,20)) # 0 thinnest, 1-4 other thicknesses,
# higher values cycle through these line thicknesses with different brush patterns.
plots = {}
panel = Panels(branch,protocol,plots)
panel.set_stim_start()

#soma and branch base
v_vec_base=h.Vector()
v=h.Vector()
t=h.Vector()

v_vec_base.record(branch.cell.branch_base(0.1)._ref_v,sec=branch.cell.branch_base)
v.record(branch.cell.soma(0.5)._ref_v,sec=branch.cell.soma)
t.record(h._ref_t,sec=branch.cell.soma)

#spines

for s_i,s in enumerate(branch.spines[1:12]):
        v_vec_spine1=h.Vector()
        v_vec_spine1_matrix.append(v_vec_spine1)

        cai_vec_spine1=h.Vector()
        cai_vec_spine1_matrix.append(cai_vec_spine1)

for s_i,s in enumerate(branch.spines[1:12]):
        v_vec_spine1_matrix[s_i].record(s.head(0.5)._ref_v,sec=s.head)
        cai_vec_spine1_matrix[s_i].record(s.head(0.5)._ref_cai,sec=s.head)

for s_i,s in enumerate(branch.spines[12:]):
        v_vec_spine2=h.Vector()
        v_vec_spine2_matrix.append(v_vec_spine2)

        cai_vec_spine2=h.Vector()
        cai_vec_spine2_matrix.append(cai_vec_spine2)

for s_i,s in enumerate(branch.spines[12:]):
        v_vec_spine2_matrix[s_i].record(s.head(0.5)._ref_v,sec=s.head)
        cai_vec_spine2_matrix[s_i].record(s.head(0.5)._ref_cai,sec=s.head)

#time_stamps = h.Vector([110,200])
theta1 = h.Vector([p['spine_point_processes'][0]['parameters']['theta_cai_RM'], p['spine_point_processes'][0]['parameters']['theta_cai_RM']])
theta2 = h.Vector([p['spine_point_processes'][2]['parameters']['theta_cai_BDNF'], p['spine_point_processes'][2]['parameters']['theta_cai_BDNF']])
theta3 = h.Vector([p['spine_point_processes'][0]['parameters']['theta_cai_RMBLK'], p['spine_point_processes'][0]['parameters']['theta_cai_RMBLK']])

# NOT REQUIRED here, specified in javascript file:

# settings = {'tstop': 250, 'nbpap': 1, 'nstim': 70}
# default_settings = dict(settings)
#
# settings11={'tstop': 250, 'nbpap': 1, 'nstim': 70}
# LTP11_settings=dict(settings11)
#
# settings12={'tstop': 250, 'nbpap': 2, 'nstim': 50}
# LTP12_settings=dict(settings12)
#
# settings14={'tstop': 250, 'nbpap': 4, 'nstim': 25}
# LTP14_settings=dict(settings14)
